<?php

namespace Ulmus\Entity;

class ObjectInstanciator {
    
    protected array $objectCallbackDefinition;
    
    public function instanciate(string $type, array $arguments) : object
    {
        if ( isset($this->objectCallbackDefinition[$type]) ) {
            return $this->objectCallbackDefinition[$type](...$arguments);
        }
        else {
            return new $type(...$arguments);
        }
    }
    
    public function registerObject(string $type, Callable $callback) : void
    {
        $this->objectCallbackDefinition[$type] = $callback;
    }
    
    public function unregisterObject(string $type) : void
    {
        unset($this->objectCallbackDefinition[$type]);
    }
    
    public function isObjectRegistered(string $type) : bool
    {
        return isset($this->objectCallbackDefinition[$type]);
    }
}
