<?php

namespace Ulmus;

use Generator;

class EntityCollection extends \ArrayObject {
    
    public function filters(Callable $callback) : Generator
    {
        $idx = 0;
        
        foreach($this as $key => $item) {
            if ( $callback($item, $key, $idx) ) {
                $idx++;
                
                yield $item;
            }
        }
    }
    
    public function searchOne($value, string $field) : object 
    {
        # Returning first value only
        foreach($this->search($value, $field) as $item) {
            return $item;
        }
    }
    
    public function search($value, string $field) : Generator 
    {
        foreach($this->filters(fn($v) => $v->$field === $value) as $item) {
            yield $item;
        }
    }
    
    public function buildArray(string $keyColumn, string $valueColumn) : array
    {
        $list = [];
        
        foreach($this as $key => $item) {
            $list[$item->$keyColumn] = $item->$valueColumn;
        }
        
        return $list;
    }
}